DataStore [kamaji.clastix.io/v1alpha1]

Description
DataStore is the Schema for the datastores API.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

DataStoreSpec defines the desired state of DataStore.

statusobject

DataStoreStatus defines the observed state of DataStore.

.spec

Description
DataStoreSpec defines the desired state of DataStore.
Type
object
Required
driverendpoints
PropertyTypeDescription
basicAuthobject

In case of authentication enabled for the given data store, specifies the username and password pair. This value is optional.

driverstring

The driver to use to connect to the shared datastore.

endpointsarray

List of the endpoints to connect to the shared datastore. No need for protocol, just bare IP/FQDN and port.

tlsConfigobject

Defines the TLS/SSL configuration required to connect to the data store in a secure way. This value is optional.

.spec.basicAuth

Description
In case of authentication enabled for the given data store, specifies the username and password pair. This value is optional.
Type
object
Required
passwordusername
PropertyTypeDescription
passwordobject
usernameobject

.spec.basicAuth.password

Type
object
PropertyTypeDescription
contentstring

Bare content of the file, base64 encoded. It has precedence over the SecretReference value.

secretReferenceobject

.spec.basicAuth.password.secretReference

Type
object
Required
keyPath
PropertyTypeDescription
keyPathstring

Name of the key for the given Secret reference where the content is stored. This value is mandatory.

namestring

name is unique within a namespace to reference a secret resource.

namespacestring

namespace defines the space within which the secret name must be unique.

.spec.basicAuth.username

Type
object
PropertyTypeDescription
contentstring

Bare content of the file, base64 encoded. It has precedence over the SecretReference value.

secretReferenceobject

.spec.basicAuth.username.secretReference

Type
object
Required
keyPath
PropertyTypeDescription
keyPathstring

Name of the key for the given Secret reference where the content is stored. This value is mandatory.

namestring

name is unique within a namespace to reference a secret resource.

namespacestring

namespace defines the space within which the secret name must be unique.

.spec.endpoints

Description
List of the endpoints to connect to the shared datastore. No need for protocol, just bare IP/FQDN and port.
Type
array

.spec.endpoints[]

Type
string

.spec.tlsConfig

Description
Defines the TLS/SSL configuration required to connect to the data store in a secure way. This value is optional.
Type
object
Required
certificateAuthority
PropertyTypeDescription
certificateAuthorityobject

Retrieve the Certificate Authority certificate and private key, such as bare content of the file, or a SecretReference. The key reference is required since etcd authentication is based on certificates, and Kamaji is responsible in creating this.

clientCertificateobject

Specifies the SSL/TLS key and private key pair used to connect to the data store.

.spec.tlsConfig.certificateAuthority

Description
Retrieve the Certificate Authority certificate and private key, such as bare content of the file, or a SecretReference. The key reference is required since etcd authentication is based on certificates, and Kamaji is responsible in creating this.
Type
object
Required
certificate
PropertyTypeDescription
certificateobject
privateKeyobject

.spec.tlsConfig.certificateAuthority.certificate

Type
object
PropertyTypeDescription
contentstring

Bare content of the file, base64 encoded. It has precedence over the SecretReference value.

secretReferenceobject

.spec.tlsConfig.certificateAuthority.certificate.secretReference

Type
object
Required
keyPath
PropertyTypeDescription
keyPathstring

Name of the key for the given Secret reference where the content is stored. This value is mandatory.

namestring

name is unique within a namespace to reference a secret resource.

namespacestring

namespace defines the space within which the secret name must be unique.

.spec.tlsConfig.certificateAuthority.privateKey

Type
object
PropertyTypeDescription
contentstring

Bare content of the file, base64 encoded. It has precedence over the SecretReference value.

secretReferenceobject

.spec.tlsConfig.certificateAuthority.privateKey.secretReference

Type
object
Required
keyPath
PropertyTypeDescription
keyPathstring

Name of the key for the given Secret reference where the content is stored. This value is mandatory.

namestring

name is unique within a namespace to reference a secret resource.

namespacestring

namespace defines the space within which the secret name must be unique.

.spec.tlsConfig.clientCertificate

Description
Specifies the SSL/TLS key and private key pair used to connect to the data store.
Type
object
Required
certificateprivateKey
PropertyTypeDescription
certificateobject
privateKeyobject

.spec.tlsConfig.clientCertificate.certificate

Type
object
PropertyTypeDescription
contentstring

Bare content of the file, base64 encoded. It has precedence over the SecretReference value.

secretReferenceobject

.spec.tlsConfig.clientCertificate.certificate.secretReference

Type
object
Required
keyPath
PropertyTypeDescription
keyPathstring

Name of the key for the given Secret reference where the content is stored. This value is mandatory.

namestring

name is unique within a namespace to reference a secret resource.

namespacestring

namespace defines the space within which the secret name must be unique.

.spec.tlsConfig.clientCertificate.privateKey

Type
object
PropertyTypeDescription
contentstring

Bare content of the file, base64 encoded. It has precedence over the SecretReference value.

secretReferenceobject

.spec.tlsConfig.clientCertificate.privateKey.secretReference

Type
object
Required
keyPath
PropertyTypeDescription
keyPathstring

Name of the key for the given Secret reference where the content is stored. This value is mandatory.

namestring

name is unique within a namespace to reference a secret resource.

namespacestring

namespace defines the space within which the secret name must be unique.

.status

Description
DataStoreStatus defines the observed state of DataStore.
Type
object
PropertyTypeDescription
usedByarray

List of the Tenant Control Planes, namespaced names, using this data store.

.status.usedBy

Description
List of the Tenant Control Planes, namespaced names, using this data store.
Type
array

.status.usedBy[]

Type
string

API Endpoints

The following API endpoints are available:

  • /apis/kamaji.clastix.io/v1alpha1/namespaces/{namespace}/datastores
    • DELETE: delete collection of DataStore
    • GET: list objects of kind DataStore
    • POST: create a new DataStore
  • /apis/kamaji.clastix.io/v1alpha1/namespaces/{namespace}/datastores/{name}
    • DELETE: delete the specified DataStore
    • GET: read the specified DataStore
    • PATCH: partially update the specified DataStore
    • PUT: replace the specified DataStore
  • /apis/kamaji.clastix.io/v1alpha1/namespaces/{namespace}/datastores/{name}/status
    • GET: read status of the specified DataStore
    • PATCH: partially update status of the specified DataStore
    • PUT: replace status of the specified DataStore

/apis/kamaji.clastix.io/v1alpha1/namespaces/{namespace}/datastores

HTTP method
DELETE
Description
delete collection of DataStore
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind DataStore
HTTP responses
HTTP codeResponse body
200 - OKDataStoreList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new DataStore
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyDataStore schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
201 - CreatedDataStore schema
202 - AcceptedDataStore schema
401 - UnauthorizedEmpty

/apis/kamaji.clastix.io/v1alpha1/namespaces/{namespace}/datastores/{name}

HTTP method
DELETE
Description
delete the specified DataStore
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified DataStore
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified DataStore
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified DataStore
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyDataStore schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
201 - CreatedDataStore schema
401 - UnauthorizedEmpty

/apis/kamaji.clastix.io/v1alpha1/namespaces/{namespace}/datastores/{name}/status

HTTP method
GET
Description
read status of the specified DataStore
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified DataStore
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified DataStore
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyDataStore schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKDataStore schema
201 - CreatedDataStore schema
401 - UnauthorizedEmpty